/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlet;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;
import middletier.SessionInfo;

/**
 *
 * @author gdestri
 */
public class SecondServlet extends HttpServlet {

    // ATTRIBUTI
    SessionInfo _sessInfo;
    
    /** 
    * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        
        // valida la sessione, rimandando sulle pagine di errore se necessario
        this.validateSession(request, response);

        
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            /* TODO output your page here */
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet SECONDA PAGINA</title>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h4> Cliccare <a href=\"/WebAppLogin/LogoutServlet\">qui</a> per uscire dalla sessione di lavoro</h4>");
            out.println("</body>");
            out.println("</html>");    
        } finally { 
            out.close();
        }
    } 

        private void validateSession(HttpServletRequest request, HttpServletResponse response) 
    throws IOException {
        
        // preleva la sessione dalla request, senza crearla se non e' valida
        HttpSession session = request.getSession(false);
        
        // se la sessione non esiste
        if (session == null)
        {
            response.sendRedirect("/WebAppLogin/ErrorServlet");
        }
        else {
            // estrae dalla sessione l'oggetto con le informazioni
            _sessInfo = (SessionInfo) session.getAttribute("sessInfo");
            
            // verifica se l'oggetto e' null
            if (_sessInfo == null) {
                // forza l'annullamento della sessione
                session.invalidate();
                
                // ridirige sulla pagina di errore
                response.sendRedirect("/WebAppLogin/ErrorServlet");
            }
            else {
                // estrae il sid dell'oggetto
                String trueSessionID = _sessInfo.getSid();
                
                // ottiene il sessionID dalla sessione corrente
                String sessionID = session.getId();
                
                // confronta i due
                if (!(trueSessionID.equals(sessionID))) 
                {
                // forza l'annullamento della sessione
                session.invalidate();
                
                // ridirige sulla pagina di errore
                response.sendRedirect("/WebAppLogin/ErrorServlet");
                }
            } // end else (_sessInfo not null) 
            
        } // end else (session not null)
       
    } // end method

    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
